/*
 * Copyright 2022, the Chromium project authors.  Please see the AUTHORS file
 * for details. All rights reserved. Use of this source code is governed by a
 * BSD-style license that can be found in the LICENSE file.
 */

package io.flutter.plugins.firebase.auth;

public class Constants {

  public static final String APP_NAME = "appName";

  // Providers
  public static final String SIGN_IN_METHOD_PASSWORD = "password";
  public static final String SIGN_IN_METHOD_EMAIL_LINK = "emailLink";
  public static final String SIGN_IN_METHOD_FACEBOOK = "facebook.com";
  public static final String SIGN_IN_METHOD_GOOGLE = "google.com";
  public static final String SIGN_IN_METHOD_TWITTER = "twitter.com";
  public static final String SIGN_IN_METHOD_GITHUB = "github.com";
  public static final String SIGN_IN_METHOD_PHONE = "phone";
  public static final String SIGN_IN_METHOD_OAUTH = "oauth";

  // User
  public static final String USER = "user";
  public static final String EMAIL = "email";

  public static final String PROVIDER_ID = "providerId";
  public static final String CREDENTIAL = "credential";
  public static final String SECRET = "secret";
  public static final String ID_TOKEN = "idToken";
  public static final String TOKEN = "token";
  public static final String ACCESS_TOKEN = "accessToken";
  public static final String RAW_NONCE = "rawNonce";
  public static final String EMAIL_LINK = "emailLink";
  public static final String VERIFICATION_ID = "verificationId";
  public static final String SMS_CODE = "smsCode";
  public static final String SIGN_IN_METHOD = "signInMethod";
  public static final String FORCE_RESENDING_TOKEN = "forceResendingToken";
  public static final String NAME = "name";

  // MultiFactor
  public static final String MULTI_FACTOR_HINTS = "multiFactorHints";
  public static final String MULTI_FACTOR_SESSION_ID = "multiFactorSessionId";
  public static final String MULTI_FACTOR_RESOLVER_ID = "multiFactorResolverId";
}
